'Hackwrench Industries
'Any questions, comments, feature requests, money, mail, systems, source code
'videos, Rescue Ranger stuff(guess where I got the name "Hackwrench" from...)
'etc, can be sent to:
'Robert Claypool
'614 Shirley, P.O. BOX 145
'Shirley, IN 47384

DEFINT A-Z
'$DYNAMIC
    TYPE MemLoc
      Segment AS INTEGER
      Offset  AS INTEGER
    END TYPE


    TYPE FileInfoType
      Reserved AS STRING * 21
      Attribute AS STRING * 1
      CreationTime AS INTEGER
      CreationDate AS INTEGER
      Size AS LONG
      FileName AS STRING * 13
    END TYPE


DECLARE SUB FileAddExtension (FileName AS STRING)


DECLARE FUNCTION FindWhereInStr% (SearchString$, lookString$, Which%)


DECLARE FUNCTION Directory.Program.Get$ ()
DECLARE SUB FileMaskMakeValid (FileMask$)

DECLARE FUNCTION IsDrive% (Value$)

DECLARE FUNCTION Token.Get$ (Search$, NonToken$, Start%)
DECLARE FUNCTION Token.End.Find% (Search$, NonToken$, Start%)
DECLARE FUNCTION Token.Start.Find% (Search$, NonToken$, Start%)
DECLARE FUNCTION Blocks.Count% (Min%, Max%)
DECLARE FUNCTION InStrCount% (SearchString$, lookString$)

DECLARE FUNCTION ENVSEG%
DECLARE SUB FETCHDIRITEM (SEG FileInfo AS FileInfoType, BYVAL Segment%, BYVAL Offset%, BYVAL Mask%)


ON ERROR GOTO ErrorHandle

temp$ = COMMAND$

    IF temp$ = "" THEN
       SHELL "CD"
       'Debug
       'PRINT 1
    ELSEIF INSTR(temp$, "=") THEN
       IF INSTR(temp$, "=") = 1 THEN PRINT "No Token Specified": END
       Temp2$ = Token.Get(temp$, " ", INSTR(temp$, "=") + 1)
       IF Temp2$ = "" THEN PRINT "No Path Specified": END
       OPEN Directory.Program.Get$ + "QCD.DAT" FOR APPEND AS #1
       PRINT #1, Token.Get(temp$, " =", 1) + "=" + UCASE$(Temp2$)
     ELSE
       ErrorType% = 0
       OPEN COMMAND$ + ".DIR" FOR INPUT AS #1
       IF ErrorType% THEN
         CLOSE
         OPEN Directory.Program.Get$ + "QCD.DAT" FOR INPUT AS #1
         DO
           LINE INPUT #1, A$
           Temp2$ = UCASE$(Token.Get(A$, " =", 1))
           IF temp$ = Temp2$ THEN
              Temp2$ = LTRIM$(MID$(A$, INSTR(A$, "=") + 1))
              IF MID$(Temp2$, 2, 1) = ":" THEN
                SHELL LEFT$(Temp2$, 2)
                IF LEN(Temp2$) = 2 THEN END
              END IF
              SHELL "CD " + Temp2$
              'PRINT 3; Temp2$, LEN(Temp2$)
              END
           END IF
         LOOP UNTIL EOF(1)
         Temp2$ = COMMAND$
         IF MID$(Temp2$, 2, 1) = ":" THEN
           SHELL LEFT$(Temp2$, 2)
           IF LEN(Temp2$) = 2 THEN END
         END IF
         ErrorType% = 0
         CHDIR Temp2$
         IF ErrorType% THEN
           Temp2$ = Temp2$ + ".*"
           CALL FileAddExtension(Temp2$)
           IF Temp2$ <> "" THEN
             SHELL "CD " + Temp2$
             'PRINT 4; Temp2$, LEN(Temp2$), ASC(LEFT$(Temp2$, 1))
           ELSE
             PRINT "Can't find " + COMMAND$
           END IF
         END IF
         END
       ELSE
           LINE INPUT #1, A$
           SHELL "CD " + A$
       END IF
    END IF

ErrorHandle:
    ErrorType% = ERR
RESUME NEXT

FUNCTION Blocks.Count% (Min%, Max%)
    Blocks.Count% = Max% - Min% + 1
END FUNCTION

FUNCTION Directory.Program.Get$
    
    DEF SEG = ENVSEG
    i = 0
    DO
      LastChar$ = CurrChar$
      CurrChar$ = CHR$(PEEK(i))
      i = i + 1
    LOOP UNTIL LastChar$ = CurrChar$ AND CurrChar$ = CHR$(0)
    IF PEEK(i) <> 1 THEN EXIT FUNCTION
    i = i + 2

    DO
    CurrChar$ = CHR$(PEEK(i))
    Test$ = Test$ + CurrChar$
    i = i + 1
    LOOP UNTIL CurrChar$ = CHR$(0)
    Directory.Program.Get = Test$ 'Make sure we return something
    FOR i = LEN(Test$) TO 1 STEP -1
        IF MID$(Test$, i, 1) = "\" THEN
           Directory.Program.Get = LEFT$(Test$, i)
           EXIT FUNCTION
        END IF
    NEXT i
END FUNCTION' Directory.Program.Get

REM $STATIC
SUB FileAddExtension (FileName AS STRING)
    DIM FileInfo AS FileInfoType, TempFile AS STRING

    TempFile = FileName + CHR$(0)

    FETCHDIRITEM FileInfo, VARSEG(TempFile), SADD(TempFile), &H10


    IF FileInfo.FileName = STRING$(13, 0) THEN
       FileName = ""
       EXIT SUB
    END IF
    FileName = LTRIM$(FileInfo.FileName)
END SUB

REM $DYNAMIC
SUB FileMaskMakeValid (FileMask$)
    LastOfFirstPart% = INSTR(FileMask$, ".")
    SELECT CASE LastOfFirstPart%
        CASE IS > 9
        FileMask$ = LEFT$(FileMask$, 8) + "." + MID$(FileMask$, LastOfFirstPart% + 1, 3)
        CASE 1
        FileMask$ = "*" + LEFT$(FileMask$, 4)
        CASE 0
        FileMask$ = LEFT$(FileMask$, 8)
    CASE ELSE
        FileMask$ = LEFT$(FileMask$, LastOfFirstPart% + 3)
    END SELECT
    IF InStrCount(FileMask$, ".") > 1 THEN
       FileMask$ = LEFT$(FileMask$, FindWhereInStr(FileMask$, ".", 2) - 1)
    END IF
    FileMask$ = FileMask$ + CHR$(0)
END SUB

FUNCTION FindWhereInStr% (SearchString$, lookString$, Which%)
    FOR i = 1 TO LEN(SearchString$) - LEN(lookString$) + 1
        IF MID$(SearchString$, i, LEN(lookString$)) = lookString$ THEN
           temp% = temp% + 1
        END IF
        IF temp% = Which% THEN
            FindWhereInStr% = i
            EXIT FUNCTION
        END IF
    NEXT i
END FUNCTION

FUNCTION InStrCount (SearchString$, lookString$)
    FOR i = 1 TO LEN(SearchString$) - LEN(lookString$) + 1
        IF MID$(SearchString$, i, LEN(lookString$)) = lookString$ THEN
           temp% = temp% + 1
        END IF
    NEXT i
    InStrCount = temp%
END FUNCTION

FUNCTION IsDrive% (Value$)
    IF MID$(Value$, 2, 1) = ":" THEN IsDrive% = -1
END FUNCTION

' Token.End.Find:
'  Searches Search$ to find the first character from among those in
'  NonToken$. Returns the index of that character. This function can
'  be used to find the end of a token.
' Input:
'  Search$ = string to search
'  NonToken$ = characters to search for
' Output:
'  Token.End.Find = index to first match in Search$ or 0 if none match
FUNCTION Token.End.Find% (Search$, NonToken$, Start%) STATIC
    ' Look for end of token (first character that is a delimiter).
    FOR i = Start% TO LEN(Search$)
       IF INSTR(NonToken$, MID$(Search$, i, 1)) <> 0 THEN
          Token.End.Find = i - 1
          EXIT FUNCTION
       END IF
    NEXT i
    Token.End.Find = LEN(Search$)
END FUNCTION

FUNCTION Token.Get$ (Search$, NonToken$, Start%) STATIC
    Start% = Token.Start.Find(Search$, NonToken$, Start%)
    IF Start% = 0 THEN EXIT FUNCTION
    ' Find end of token
    temp% = Token.End.Find(Search$, NonToken$, Start%)
    Token.Get = MID$(Search$, Start%, Blocks.Count(Start%, temp%))
    Start% = temp% + 1
END FUNCTION

' Token.Start:
'  Searches Search$ to find the first character that is not one of
'  those in NonToken$. Returns the index of that character. This
'  function can be used to find the start of a token.
' Input:
'  Search$ = string to search
'  NonToken$ = characters to search for
' Output:
'  Token.Start = index to first nonmatch in Search$ or 0 if all match
FUNCTION Token.Start.Find% (Search$, NonToken$, Start%) STATIC
    ' Look for start of a token (character that isn't a delimiter).
    FOR i = Start% TO LEN(Search$)
        IF INSTR(NonToken$, MID$(Search$, i, 1)) = 0 THEN
           Token.Start.Find% = i
           EXIT FUNCTION
        END IF
    NEXT i
END FUNCTION

